local z=require"luci.dispatcher"
local y,e,x,v,p,j
local u,q,f,t,l
local k,d,c,r
local m,s,i,o
local b,a,h,n,w,g
arg[1]=arg[1]or""
y=Map("mwan3",translatef("MWAN Interface Configuration - %s",arg[1]))
y.redirect=z.build_url("admin","network","mwan","interface")
e=y:section(NamedSection,arg[1],"interface","")
e.addremove=false
e.dynamic=false
x=e:option(Flag,"enabled",translate("Enabled"))
x.default=false
v=e:option(ListValue,"initial_state",translate("Initial state"),
translate("Expect interface state on up event"))
v.default="online"
v:value("online",translate("Online"))
v:value("offline",translate("Offline"))
p=e:option(ListValue,"family",translate("Internet Protocol"))
p.default="ipv4"
p:value("ipv4",translate("IPv4"))
p:value("ipv6",translate("IPv6"))
j=e:option(DynamicList,"track_ip",translate("Tracking hostname or IP address"),
translate("This hostname or IP address will be pinged to determine if the link is up or down. Leave blank to assume interface is always online"))
j.datatype="host"
u=e:option(ListValue,"track_method",translate("Tracking method"))
u.default="ping"
u:value("ping")
if os.execute("which nping 1>/dev/null")==0 then
u:value("nping-tcp")
u:value("nping-udp")
u:value("nping-icmp")
u:value("nping-arp")
end
if os.execute("which arping 1>/dev/null")==0 then
u:value("arping")
end
if os.execute("which httping 1>/dev/null")==0 then
u:value("httping")
end
q=e:option(Value,"reliability",translate("Tracking reliability"),
translate("Acceptable values: 1-100. This many Tracking IP addresses must respond for the link to be deemed up"))
q.datatype="range(1, 100)"
q.default="1"
f=e:option(ListValue,"count",translate("Ping count"))
f.default="1"
f:value("1")
f:value("2")
f:value("3")
f:value("4")
f:value("5")
t=e:option(Value,"size",translate("Ping size"))
t.default="56"
t:depends("track_method","ping")
t:value("8")
t:value("24")
t:value("56")
t:value("120")
t:value("248")
t:value("504")
t:value("1016")
t:value("1472")
t:value("2040")
t.datatype="range(1, 65507)"
t.rmempty=false
t.optional=false
l=e:option(Value,"max_ttl",translate("Max TTL"))
l.default="60"
l:depends("track_method","ping")
l:value("10")
l:value("20")
l:value("30")
l:value("40")
l:value("50")
l:value("60")
l:value("70")
l.datatype="range(1, 255)"
k=e:option(Flag,"check_quality",translate("Check link quality"))
k:depends("track_method","ping")
k.default=false
d=e:option(Value,"failure_latency",translate("Max packet latency [ms]"))
d:depends("check_quality",1)
d.default="1000"
d:value("25")
d:value("50")
d:value("75")
d:value("100")
d:value("150")
d:value("200")
d:value("250")
d:value("300")
c=e:option(Value,"failure_loss",translate("Max packet loss [%]"))
c:depends("check_quality",1)
c.default="20"
c:value("2")
c:value("5")
c:value("10")
c:value("20")
c:value("25")
r=e:option(Value,"recovery_latency",translate("Min packet latency [ms]"))
r:depends("check_quality",1)
r.default="500"
r:value("25")
r:value("50")
r:value("75")
r:value("100")
r:value("150")
r:value("200")
r:value("250")
r:value("300")
m=e:option(Value,"recovery_loss",translate("Min packet loss [%]"))
m:depends("check_quality",1)
m.default="5"
m:value("2")
m:value("5")
m:value("10")
m:value("20")
m:value("25")
s=e:option(ListValue,"timeout",translate("Ping timeout"))
s.default="2"
s:value("1",translatef("%d second",1))
s:value("2",translatef("%d seconds",2))
s:value("3",translatef("%d seconds",3))
s:value("4",translatef("%d seconds",4))
s:value("5",translatef("%d seconds",5))
s:value("6",translatef("%d seconds",6))
s:value("7",translatef("%d seconds",7))
s:value("8",translatef("%d seconds",8))
s:value("9",translatef("%d seconds",9))
s:value("10",translatef("%d seconds",10))
i=e:option(ListValue,"interval",translate("Ping interval"))
i.default="5"
i:value("1",translatef("%d second",1))
i:value("3",translatef("%d seconds",3))
i:value("5",translatef("%d seconds",5))
i:value("10",translatef("%d seconds",10))
i:value("20",translatef("%d seconds",20))
i:value("30",translatef("%d seconds",30))
i:value("60",translatef("%d minute",1))
i:value("300",translatef("%d minutes",5))
i:value("600",translatef("%d minutes",10))
i:value("900",translatef("%d minutes",15))
i:value("1800",translatef("%d minutes",30))
i:value("3600",translatef("%d hour",1))
o=e:option(Value,"failure_interval",translate("Failure interval"),
translate("Ping interval during failure detection"))
o.default="5"
o:value("1",translatef("%d second",1))
o:value("3",translatef("%d seconds",3))
o:value("5",translatef("%d seconds",5))
o:value("10",translatef("%d seconds",10))
o:value("20",translatef("%d seconds",20))
o:value("30",translatef("%d seconds",30))
o:value("60",translatef("%d minute",1))
o:value("300",translatef("%d minutes",5))
o:value("600",translatef("%d minutes",10))
o:value("900",translatef("%d minutes",15))
o:value("1800",translatef("%d minutes",30))
o:value("3600",translatef("%d hour",1))
b=e:option(Flag,"keep_failure_interval",translate("Keep failure interval"),
translate("Keep ping failure interval during failure state"))
b.default=b.disabled
a=e:option(Value,"recovery_interval",translate("Recovery interval"),
translate("Ping interval during failure recovering"))
a.default="5"
a:value("1",translatef("%d second",1))
a:value("3",translatef("%d seconds",3))
a:value("5",translatef("%d seconds",5))
a:value("10",translatef("%d seconds",10))
a:value("20",translatef("%d seconds",20))
a:value("30",translatef("%d seconds",30))
a:value("60",translatef("%d minute",1))
a:value("300",translatef("%d minutes",5))
a:value("600",translatef("%d minutes",10))
a:value("900",translatef("%d minutes",15))
a:value("1800",translatef("%d minutes",30))
a:value("3600",translatef("%d hour",1))
h=e:option(ListValue,"down",translate("Interface down"),
translate("Interface will be deemed down after this many failed ping tests"))
h.default="3"
h:value("1")
h:value("2")
h:value("3")
h:value("4")
h:value("5")
h:value("6")
h:value("7")
h:value("8")
h:value("9")
h:value("10")
n=e:option(ListValue,"up",translate("Interface up"),
translate("Downed interface will be deemed up after this many successful ping tests"))
n.default="3"
n:value("1")
n:value("2")
n:value("3")
n:value("4")
n:value("5")
n:value("6")
n:value("7")
n:value("8")
n:value("9")
n:value("10")
w=e:option(StaticList,"flush_conntrack",translate("Flush conntrack table"),
translate("Flush global firewall conntrack table on interface events"))
w:value("ifup",translate("ifup (netifd)"))
w:value("ifdown",translate("ifdown (netifd)"))
w:value("connected",translate("connected (mwan3)"))
w:value("disconnected",translate("disconnected (mwan3)"))
g=e:option(DummyValue,"metric",translate("Metric"),
translate("This displays the metric assigned to this interface in /etc/config/network"))
g.rawhtml=true
function g.cfgvalue(e,e)
local e=require"luci.model.uci".cursor(nil,"/var/state")
local e=e:get("network",arg[1],"metric")
if e then
return e
else
return"&#8212;"
end
end
return y
